/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ExtractedMetadataTreeForCreationDto } from '../../@coscine/model';
// @ts-ignore
import type { ExtractedMetadataTreeForUpdateDto } from '../../@coscine/model';
// @ts-ignore
import type { FileTreeDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { MetadataTreeDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { MetadataTreeDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { MetadataTreeForCreationDto } from '../../@coscine/model';
// @ts-ignore
import type { MetadataTreeForDeletionDto } from '../../@coscine/model';
// @ts-ignore
import type { MetadataTreeForUpdateDto } from '../../@coscine/model';
// @ts-ignore
import type { RdfFormat } from '../../@coscine/model';
/**
 * TreeApi - axios parameter creator
 * @export
 */
export const TreeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdTreesOptions: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdTreesOptions', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdTreesOptions', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Creates a new extracted metadata tree for a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ExtractedMetadataTreeForCreationDto} [extractedMetadataTreeForCreationDto] The metadata tree data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createExtractedMetadataTree: async (projectId: string, resourceId: string, extractedMetadataTreeForCreationDto?: ExtractedMetadataTreeForCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createExtractedMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('createExtractedMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata/extracted`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(extractedMetadataTreeForCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Creates a new metadata tree for a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForCreationDto} [metadataTreeForCreationDto] The metadata tree data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createMetadataTree: async (projectId: string, resourceId: string, metadataTreeForCreationDto?: MetadataTreeForCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('createMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(metadataTreeForCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Deletes (invalidates) a metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForDeletionDto} [metadataTreeForDeletionDto] The dto for the deletion.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMetadataTree: async (projectId: string, resourceId: string, metadataTreeForDeletionDto?: MetadataTreeForDeletionDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('deleteMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('deleteMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(metadataTreeForDeletionDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * The `OrderBy` query is currently not supported.
         * @summary Retrieves the file tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} [path] Gets or sets the path of the file tree.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFileTree: async (projectId: string, resourceId: string, path?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getFileTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getFileTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/files`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (path !== undefined) {
                localVarQueryParameter['Path'] = path;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} [path] Gets or sets the path of the metadata tree.
         * @param {RdfFormat} [format] Gets or sets the format of the RDF data.
         * @param {boolean} [includeExtractedMetadata] Gets or sets if extracted metadata should be included.
         * @param {boolean} [includeProvenance] Gets or sets if provenance metadata should be included.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetadataTree: async (projectId: string, resourceId: string, path?: string, format?: RdfFormat, includeExtractedMetadata?: boolean, includeProvenance?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (path !== undefined) {
                localVarQueryParameter['Path'] = path;
            }

            if (format !== undefined) {
                localVarQueryParameter['Format'] = format;
            }

            if (includeExtractedMetadata !== undefined) {
                localVarQueryParameter['IncludeExtractedMetadata'] = includeExtractedMetadata;
            }

            if (includeProvenance !== undefined) {
                localVarQueryParameter['IncludeProvenance'] = includeProvenance;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the specific metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} path Gets or sets the path of the metadata tree.
         * @param {RdfFormat} [format] Gets or sets the format of the RDF data.
         * @param {boolean} [includeExtractedMetadata] Gets or sets if extracted metadata should be included.
         * @param {boolean} [includeProvenance] Gets or sets if provenance should be included.
         * @param {number} [version] Gets or sets the desired version.  If the version is null, the newest will be returned.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSpecificMetadataTree: async (projectId: string, resourceId: string, path: string, format?: RdfFormat, includeExtractedMetadata?: boolean, includeProvenance?: boolean, version?: number, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getSpecificMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getSpecificMetadataTree', 'resourceId', resourceId)
            // verify required parameter 'path' is not null or undefined
            assertParamExists('getSpecificMetadataTree', 'path', path)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata/specific`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (path !== undefined) {
                localVarQueryParameter['Path'] = path;
            }

            if (format !== undefined) {
                localVarQueryParameter['Format'] = format;
            }

            if (includeExtractedMetadata !== undefined) {
                localVarQueryParameter['IncludeExtractedMetadata'] = includeExtractedMetadata;
            }

            if (includeProvenance !== undefined) {
                localVarQueryParameter['IncludeProvenance'] = includeProvenance;
            }

            if (version !== undefined) {
                localVarQueryParameter['Version'] = version;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates an existing metadata tree of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ExtractedMetadataTreeForUpdateDto} [extractedMetadataTreeForUpdateDto] The updated metadata tree data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateExtractedMetadataTree: async (projectId: string, resourceId: string, extractedMetadataTreeForUpdateDto?: ExtractedMetadataTreeForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateExtractedMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('updateExtractedMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata/extracted`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(extractedMetadataTreeForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates an existing metadata tree of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForUpdateDto} [metadataTreeForUpdateDto] The updated metadata tree data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMetadataTree: async (projectId: string, resourceId: string, metadataTreeForUpdateDto?: MetadataTreeForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateMetadataTree', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('updateMetadataTree', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/trees/metadata`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(metadataTreeForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TreeApi - functional programming interface
 * @export
 */
export const TreeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TreeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.apiV2ProjectsProjectIdResourcesResourceIdTreesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Creates a new extracted metadata tree for a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ExtractedMetadataTreeForCreationDto} [extractedMetadataTreeForCreationDto] The metadata tree data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createExtractedMetadataTree(projectId: string, resourceId: string, extractedMetadataTreeForCreationDto?: ExtractedMetadataTreeForCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MetadataTreeDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createExtractedMetadataTree(projectId, resourceId, extractedMetadataTreeForCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.createExtractedMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Creates a new metadata tree for a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForCreationDto} [metadataTreeForCreationDto] The metadata tree data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createMetadataTree(projectId: string, resourceId: string, metadataTreeForCreationDto?: MetadataTreeForCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MetadataTreeDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createMetadataTree(projectId, resourceId, metadataTreeForCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.createMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Deletes (invalidates) a metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForDeletionDto} [metadataTreeForDeletionDto] The dto for the deletion.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteMetadataTree(projectId: string, resourceId: string, metadataTreeForDeletionDto?: MetadataTreeForDeletionDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteMetadataTree(projectId, resourceId, metadataTreeForDeletionDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.deleteMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * The `OrderBy` query is currently not supported.
         * @summary Retrieves the file tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} [path] Gets or sets the path of the file tree.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getFileTree(projectId: string, resourceId: string, path?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FileTreeDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getFileTree(projectId, resourceId, path, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.getFileTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} [path] Gets or sets the path of the metadata tree.
         * @param {RdfFormat} [format] Gets or sets the format of the RDF data.
         * @param {boolean} [includeExtractedMetadata] Gets or sets if extracted metadata should be included.
         * @param {boolean} [includeProvenance] Gets or sets if provenance metadata should be included.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getMetadataTree(projectId: string, resourceId: string, path?: string, format?: RdfFormat, includeExtractedMetadata?: boolean, includeProvenance?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MetadataTreeDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getMetadataTree(projectId, resourceId, path, format, includeExtractedMetadata, includeProvenance, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.getMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the specific metadata tree associated with a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {string} path Gets or sets the path of the metadata tree.
         * @param {RdfFormat} [format] Gets or sets the format of the RDF data.
         * @param {boolean} [includeExtractedMetadata] Gets or sets if extracted metadata should be included.
         * @param {boolean} [includeProvenance] Gets or sets if provenance should be included.
         * @param {number} [version] Gets or sets the desired version.  If the version is null, the newest will be returned.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getSpecificMetadataTree(projectId: string, resourceId: string, path: string, format?: RdfFormat, includeExtractedMetadata?: boolean, includeProvenance?: boolean, version?: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MetadataTreeDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getSpecificMetadataTree(projectId, resourceId, path, format, includeExtractedMetadata, includeProvenance, version, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.getSpecificMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates an existing metadata tree of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {ExtractedMetadataTreeForUpdateDto} [extractedMetadataTreeForUpdateDto] The updated metadata tree data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateExtractedMetadataTree(projectId: string, resourceId: string, extractedMetadataTreeForUpdateDto?: ExtractedMetadataTreeForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateExtractedMetadataTree(projectId, resourceId, extractedMetadataTreeForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.updateExtractedMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Updates an existing metadata tree of a resource.
         * @param {string} projectId The unique identifier or slug of the project.
         * @param {string} resourceId The unique identifier of the resource.
         * @param {MetadataTreeForUpdateDto} [metadataTreeForUpdateDto] The updated metadata tree data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateMetadataTree(projectId: string, resourceId: string, metadataTreeForUpdateDto?: MetadataTreeForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateMetadataTree(projectId, resourceId, metadataTreeForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['TreeApi.updateMetadataTree']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * TreeApi - factory interface
 * @export
 */
export const TreeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TreeApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(requestParameters: TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Creates a new extracted metadata tree for a resource.
         * @param {TreeApiCreateExtractedMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createExtractedMetadataTree(requestParameters: TreeApiCreateExtractedMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<MetadataTreeDtoResponse> {
            return localVarFp.createExtractedMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.extractedMetadataTreeForCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Creates a new metadata tree for a resource.
         * @param {TreeApiCreateMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createMetadataTree(requestParameters: TreeApiCreateMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<MetadataTreeDtoResponse> {
            return localVarFp.createMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Deletes (invalidates) a metadata tree associated with a resource.
         * @param {TreeApiDeleteMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMetadataTree(requestParameters: TreeApiDeleteMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deleteMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForDeletionDto, options).then((request) => request(axios, basePath));
        },
        /**
         * The `OrderBy` query is currently not supported.
         * @summary Retrieves the file tree associated with a resource.
         * @param {TreeApiGetFileTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFileTree(requestParameters: TreeApiGetFileTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<FileTreeDtoPagedResponse> {
            return localVarFp.getFileTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the metadata tree associated with a resource.
         * @param {TreeApiGetMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetadataTree(requestParameters: TreeApiGetMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<MetadataTreeDtoPagedResponse> {
            return localVarFp.getMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.format, requestParameters.includeExtractedMetadata, requestParameters.includeProvenance, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the specific metadata tree associated with a resource.
         * @param {TreeApiGetSpecificMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getSpecificMetadataTree(requestParameters: TreeApiGetSpecificMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<MetadataTreeDtoResponse> {
            return localVarFp.getSpecificMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.format, requestParameters.includeExtractedMetadata, requestParameters.includeProvenance, requestParameters.version, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates an existing metadata tree of a resource.
         * @param {TreeApiUpdateExtractedMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateExtractedMetadataTree(requestParameters: TreeApiUpdateExtractedMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateExtractedMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.extractedMetadataTreeForUpdateDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates an existing metadata tree of a resource.
         * @param {TreeApiUpdateMetadataTreeRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMetadataTree(requestParameters: TreeApiUpdateMetadataTreeRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdResourcesResourceIdTreesOptions operation in TreeApi.
 * @export
 * @interface TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest
 */
export interface TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptions
     */
    readonly projectId: string

    /**
     * 
     * @type {string}
     * @memberof TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptions
     */
    readonly resourceId: string
}

/**
 * Request parameters for createExtractedMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiCreateExtractedMetadataTreeRequest
 */
export interface TreeApiCreateExtractedMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiCreateExtractedMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiCreateExtractedMetadataTree
     */
    readonly resourceId: string

    /**
     * The metadata tree data for creation.
     * @type {ExtractedMetadataTreeForCreationDto}
     * @memberof TreeApiCreateExtractedMetadataTree
     */
    readonly extractedMetadataTreeForCreationDto?: ExtractedMetadataTreeForCreationDto
}

/**
 * Request parameters for createMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiCreateMetadataTreeRequest
 */
export interface TreeApiCreateMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiCreateMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiCreateMetadataTree
     */
    readonly resourceId: string

    /**
     * The metadata tree data for creation.
     * @type {MetadataTreeForCreationDto}
     * @memberof TreeApiCreateMetadataTree
     */
    readonly metadataTreeForCreationDto?: MetadataTreeForCreationDto
}

/**
 * Request parameters for deleteMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiDeleteMetadataTreeRequest
 */
export interface TreeApiDeleteMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiDeleteMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiDeleteMetadataTree
     */
    readonly resourceId: string

    /**
     * The dto for the deletion.
     * @type {MetadataTreeForDeletionDto}
     * @memberof TreeApiDeleteMetadataTree
     */
    readonly metadataTreeForDeletionDto?: MetadataTreeForDeletionDto
}

/**
 * Request parameters for getFileTree operation in TreeApi.
 * @export
 * @interface TreeApiGetFileTreeRequest
 */
export interface TreeApiGetFileTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiGetFileTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiGetFileTree
     */
    readonly resourceId: string

    /**
     * Gets or sets the path of the file tree.
     * @type {string}
     * @memberof TreeApiGetFileTree
     */
    readonly path?: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof TreeApiGetFileTree
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof TreeApiGetFileTree
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof TreeApiGetFileTree
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiGetMetadataTreeRequest
 */
export interface TreeApiGetMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiGetMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiGetMetadataTree
     */
    readonly resourceId: string

    /**
     * Gets or sets the path of the metadata tree.
     * @type {string}
     * @memberof TreeApiGetMetadataTree
     */
    readonly path?: string

    /**
     * Gets or sets the format of the RDF data.
     * @type {RdfFormat}
     * @memberof TreeApiGetMetadataTree
     */
    readonly format?: RdfFormat

    /**
     * Gets or sets if extracted metadata should be included.
     * @type {boolean}
     * @memberof TreeApiGetMetadataTree
     */
    readonly includeExtractedMetadata?: boolean

    /**
     * Gets or sets if provenance metadata should be included.
     * @type {boolean}
     * @memberof TreeApiGetMetadataTree
     */
    readonly includeProvenance?: boolean

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof TreeApiGetMetadataTree
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof TreeApiGetMetadataTree
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof TreeApiGetMetadataTree
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getSpecificMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiGetSpecificMetadataTreeRequest
 */
export interface TreeApiGetSpecificMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly resourceId: string

    /**
     * Gets or sets the path of the metadata tree.
     * @type {string}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly path: string

    /**
     * Gets or sets the format of the RDF data.
     * @type {RdfFormat}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly format?: RdfFormat

    /**
     * Gets or sets if extracted metadata should be included.
     * @type {boolean}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly includeExtractedMetadata?: boolean

    /**
     * Gets or sets if provenance should be included.
     * @type {boolean}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly includeProvenance?: boolean

    /**
     * Gets or sets the desired version.  If the version is null, the newest will be returned.
     * @type {number}
     * @memberof TreeApiGetSpecificMetadataTree
     */
    readonly version?: number
}

/**
 * Request parameters for updateExtractedMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiUpdateExtractedMetadataTreeRequest
 */
export interface TreeApiUpdateExtractedMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiUpdateExtractedMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiUpdateExtractedMetadataTree
     */
    readonly resourceId: string

    /**
     * The updated metadata tree data.
     * @type {ExtractedMetadataTreeForUpdateDto}
     * @memberof TreeApiUpdateExtractedMetadataTree
     */
    readonly extractedMetadataTreeForUpdateDto?: ExtractedMetadataTreeForUpdateDto
}

/**
 * Request parameters for updateMetadataTree operation in TreeApi.
 * @export
 * @interface TreeApiUpdateMetadataTreeRequest
 */
export interface TreeApiUpdateMetadataTreeRequest {
    /**
     * The unique identifier or slug of the project.
     * @type {string}
     * @memberof TreeApiUpdateMetadataTree
     */
    readonly projectId: string

    /**
     * The unique identifier of the resource.
     * @type {string}
     * @memberof TreeApiUpdateMetadataTree
     */
    readonly resourceId: string

    /**
     * The updated metadata tree data.
     * @type {MetadataTreeForUpdateDto}
     * @memberof TreeApiUpdateMetadataTree
     */
    readonly metadataTreeForUpdateDto?: MetadataTreeForUpdateDto
}

/**
 * TreeApi - object-oriented interface
 * @export
 * @class TreeApi
 * @extends {BaseAPI}
 */
export class TreeApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(requestParameters: TreeApiApiV2ProjectsProjectIdResourcesResourceIdTreesOptionsRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).apiV2ProjectsProjectIdResourcesResourceIdTreesOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Creates a new extracted metadata tree for a resource.
     * @param {TreeApiCreateExtractedMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public createExtractedMetadataTree(requestParameters: TreeApiCreateExtractedMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).createExtractedMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.extractedMetadataTreeForCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Creates a new metadata tree for a resource.
     * @param {TreeApiCreateMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public createMetadataTree(requestParameters: TreeApiCreateMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).createMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Deletes (invalidates) a metadata tree associated with a resource.
     * @param {TreeApiDeleteMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public deleteMetadataTree(requestParameters: TreeApiDeleteMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).deleteMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForDeletionDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * The `OrderBy` query is currently not supported.
     * @summary Retrieves the file tree associated with a resource.
     * @param {TreeApiGetFileTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public getFileTree(requestParameters: TreeApiGetFileTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).getFileTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the metadata tree associated with a resource.
     * @param {TreeApiGetMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public getMetadataTree(requestParameters: TreeApiGetMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).getMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.format, requestParameters.includeExtractedMetadata, requestParameters.includeProvenance, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the specific metadata tree associated with a resource.
     * @param {TreeApiGetSpecificMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public getSpecificMetadataTree(requestParameters: TreeApiGetSpecificMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).getSpecificMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.path, requestParameters.format, requestParameters.includeExtractedMetadata, requestParameters.includeProvenance, requestParameters.version, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Updates an existing metadata tree of a resource.
     * @param {TreeApiUpdateExtractedMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public updateExtractedMetadataTree(requestParameters: TreeApiUpdateExtractedMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).updateExtractedMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.extractedMetadataTreeForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates an existing metadata tree of a resource.
     * @param {TreeApiUpdateMetadataTreeRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TreeApi
     */
    public updateMetadataTree(requestParameters: TreeApiUpdateMetadataTreeRequest, options?: RawAxiosRequestConfig) {
        return TreeApiFp(this.configuration).updateMetadataTree(requestParameters.projectId, requestParameters.resourceId, requestParameters.metadataTreeForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

